/*#######################################################################################
Connect AVR to MMC/SD 

Copyright (C) 2004 Ulrich Radig
#######################################################################################*/

#ifndef _MMC_H_
 #define _MMC_H_

//If use MMC-Card then set to 1
#define	USE_MMC 			1       //EXPERIMENTAL NOT READY!!!!

#define SPI_Mode			1		//1 = Hardware SPI | 0 = Software SPI
//#define SPI_Mode			0

#define MMC_Write			PORTB	//Port an der die MMC/SD-Karte angeschlossen ist also des SPI 
#define MMC_Read			PINB
#define MMC_Direction_REG	DDRB	

#if defined (__AVR_ATmega128__)
	#define SPI_DI				3		//Port Pin an dem Data Output der MMC/SD-Karte angeschlossen ist 
	#define SPI_DO				2		//Port Pin an dem Data Input der MMC/SD-Karte angeschlossen ist
	#define SPI_Clock			1		//Port Pin an dem die Clock der MMC/SD-Karte angeschlossen ist (clk)
	#define MMC_Chip_Select		4		//Port Pin an dem Chip Select der MMC/SD-Karte angeschlossen ist
	#define SPI_SS				0		//Nicht Benutz mu aber definiert werden
#endif

#if defined (__AVR_ATmega32__)
	#define SPI_DI				6		//Port Pin an dem Data Output der MMC/SD-Karte angeschlossen ist 
	#define SPI_DO				5		//Port Pin an dem Data Input der MMC/SD-Karte angeschlossen ist
	#define SPI_Clock			7		//Port Pin an dem die Clock der MMC/SD-Karte angeschlossen ist (clk)
	#define MMC_Chip_Select		3		//Port Pin an dem Chip Select der MMC/SD-Karte angeschlossen ist
	#define SPI_SS				4		//Nicht Benutz mu aber definiert werden
#endif

#if defined (__AVR_ATmega162__)
	#define SPI_Clock			7		//Clock der MMC/SD-Karte FPGA 22
	#define SPI_DI				6		//Data Output der MMC/SD-Karte FPGA 20
	#define SPI_DO				5		//Data Input der MMC/SD-Karte FPGA 21
	#define FPGA_Chip_Select		4		//Chip Select des FPGA 17
	#define SPI_SS				3		//Chip Select der MMC/SD-Karte FPGA 19
	#define VS_DCS				2		//Chip Select VSdata FPGA 73
	#define VS_CCS				1		//Chip Select VScontrol FPGA 18
	#define VS_DREQ				0		//Port Pin VS
#endif	

//Prototypes
inline unsigned char Read_Byte_MMC(void);

inline void Write_Byte_MMC(unsigned char);

extern void MMC_Read_Block(unsigned char *,unsigned int);

extern unsigned char mmc_init(void);

extern unsigned char mmc_read_sector (unsigned long);

extern unsigned char mmc_config_sector (unsigned long);

extern unsigned char mmc_memory_sector (unsigned long);

extern unsigned char mmc_write_sector (unsigned long,unsigned char *);

extern unsigned char Write_Command_MMC (unsigned char *);

extern void FPGA_write_addr (unsigned int);

extern unsigned char Read_CSD_MMC (unsigned char *);

extern unsigned char Read_CID_MMC (unsigned char *);

//set FPGA_Chip_Select to high (MMC/SD-Karte Inaktiv)
#define FPGA_Disable() MMC_Write|= (1<<FPGA_Chip_Select);

//set FPGA_Chip_Select to low (MMC/SD-Karte Aktiv)
#define FPGA_Enable() MMC_Write&=~(1<<FPGA_Chip_Select);

//set MMC_Chip_Select to high (MMC/SD-Karte Inaktiv)
#define MMC_Disable() MMC_Write|= (1<<SPI_SS);

//set MMC_Chip_Select to low (MMC/SD-Karte Aktiv)
#define MMC_Enable() MMC_Write&=~(1<<SPI_SS);

#define nop()  __asm__ __volatile__ ("nop" ::)

#endif //_MMC_H_


